/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.ImportiAnticipoRecord;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ImportiAnticipo extends TableImpl<ImportiAnticipoRecord> {

    private static final long serialVersionUID = -75815776;

    /**
     * The reference instance of <code>IMPORTI_ANTICIPO</code>
     */
    public static final ImportiAnticipo IMPORTI_ANTICIPO = new ImportiAnticipo();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ImportiAnticipoRecord> getRecordType() {
        return ImportiAnticipoRecord.class;
    }

    /**
     * The column <code>IMPORTI_ANTICIPO.ID_IMPORTO_ANTICIPO</code>.
     */
    public final TableField<ImportiAnticipoRecord, Integer> ID_IMPORTO_ANTICIPO = createField("ID_IMPORTO_ANTICIPO", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_INIZIO</code>.
     */
    public final TableField<ImportiAnticipoRecord, Timestamp> PERIODO_PERTINENZA_INIZIO = createField("PERIODO_PERTINENZA_INIZIO", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_FINE</code>.
     */
    public final TableField<ImportiAnticipoRecord, Timestamp> PERIODO_PERTINENZA_FINE = createField("PERIODO_PERTINENZA_FINE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.NUMERO_FATTURA</code>.
     */
    public final TableField<ImportiAnticipoRecord, String> NUMERO_FATTURA = createField("NUMERO_FATTURA", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.IMPORTO_ORIGINALE</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> IMPORTO_ORIGINALE = createField("IMPORTO_ORIGINALE", org.jooq.impl.SQLDataType.DECIMAL(12, 2).nullable(false), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZABILE</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> IMPORTO_UTILIZZABILE = createField("IMPORTO_UTILIZZABILE", org.jooq.impl.SQLDataType.DECIMAL(12, 2).nullable(false), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.ID_INVOICE</code>.
     */
    public final TableField<ImportiAnticipoRecord, Integer> ID_INVOICE = createField("ID_INVOICE", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> IMPORTO_ACCANTONATO = createField("IMPORTO_ACCANTONATO", org.jooq.impl.SQLDataType.DECIMAL(12, 4), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.PERCENTUALE_ACCANTONAMENTO</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> PERCENTUALE_ACCANTONAMENTO = createField("PERCENTUALE_ACCANTONAMENTO", org.jooq.impl.SQLDataType.DECIMAL(12, 4), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.NOTE</code>.
     */
    public final TableField<ImportiAnticipoRecord, String> NOTE = createField("NOTE", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO_UTILIZZABILE</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> IMPORTO_ACCANTONATO_UTILIZZABILE = createField("IMPORTO_ACCANTONATO_UTILIZZABILE", org.jooq.impl.SQLDataType.DECIMAL(12, 4), this, "");

    /**
     * The column <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZATO_RECLAMI</code>.
     */
    public final TableField<ImportiAnticipoRecord, BigDecimal> IMPORTO_UTILIZZATO_RECLAMI = createField("IMPORTO_UTILIZZATO_RECLAMI", org.jooq.impl.SQLDataType.DECIMAL(12, 4), this, "");

    /**
     * Create a <code>IMPORTI_ANTICIPO</code> table reference
     */
    public ImportiAnticipo() {
        this(DSL.name("IMPORTI_ANTICIPO"), null);
    }

    /**
     * Create an aliased <code>IMPORTI_ANTICIPO</code> table reference
     */
    public ImportiAnticipo(String alias) {
        this(DSL.name(alias), IMPORTI_ANTICIPO);
    }

    /**
     * Create an aliased <code>IMPORTI_ANTICIPO</code> table reference
     */
    public ImportiAnticipo(Name alias) {
        this(alias, IMPORTI_ANTICIPO);
    }

    private ImportiAnticipo(Name alias, Table<ImportiAnticipoRecord> aliased) {
        this(alias, aliased, null);
    }

    private ImportiAnticipo(Name alias, Table<ImportiAnticipoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> ImportiAnticipo(Table<O> child, ForeignKey<O, ImportiAnticipoRecord> key) {
        super(child, key, IMPORTI_ANTICIPO);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.IMPORTI_ANTICIPO_FK_IMPORTI_ANTICIPO_1_IDX, Indexes.IMPORTI_ANTICIPO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ImportiAnticipoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_IMPORTI_ANTICIPO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ImportiAnticipoRecord> getPrimaryKey() {
        return Keys.KEY_IMPORTI_ANTICIPO_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ImportiAnticipoRecord>> getKeys() {
        return Arrays.<UniqueKey<ImportiAnticipoRecord>>asList(Keys.KEY_IMPORTI_ANTICIPO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ImportiAnticipoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ImportiAnticipoRecord, ?>>asList(Keys.FK_IMPORTI_ANTICIPO_1);
    }

    public Invoice invoice() {
        return new Invoice(this, Keys.FK_IMPORTI_ANTICIPO_1);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipo as(String alias) {
        return new ImportiAnticipo(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipo as(Name alias) {
        return new ImportiAnticipo(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public ImportiAnticipo rename(String name) {
        return new ImportiAnticipo(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public ImportiAnticipo rename(Name name) {
        return new ImportiAnticipo(name, null);
    }
}
